package fourmi;
import java.util.*;

//version simplifiée par rapport au sujet : pas de reines

class Fourmilliere{
	private ArrayList<Fourmi> t;
	Fourmilliere(){
		this.t = new ArrayList<Fourmi>();
		for(int i=0;i < 8 ;i++){
			this.t.add(new FourmiLarveMale());
		}	
		this.t.add(new FourmiAdulteMale());
		this.t.add(new FourmiAdulteMale());
	}

	public String toString(){
		String res = "";
		for (int i=0; i<this.t.size(); i++){
			res = res + this.t.get(i).toString() + "\n";
		}	
		return res;
	}

	public void evoluer() throws ViellirException{
		ArrayList<Fourmi> toadd = new ArrayList<Fourmi>();
		//va contenir toutes les larves qui viennent d'éclore

		for (int i=0; i<this.t.size(); i++){
			Fourmi f = this.t.get(i);
			Fourmi res = f.evoluer();
			if(res==null){
				//f était une fourmi adulte, qui vient de mourrir
				this.t.remove(i);
				i=i-1; //car remove tasse la liste (beurk)			
			}
			else if(res != f){
				//veut dire que f était une larve, qui s'est transformée
				//en une nouvelle fourmi	
				this.t.remove(i);
				i=i-1; //car remove tasse la liste (beurk)
				toadd.add(res);
			}
		}
		// on ajoute les nouvelles fourmi seulement à la fin (sinon une larve qui 
		// vient d'éclore evoluerait une deuxième fois en un jour)

		for (int i=0; i<toadd.size(); i++){
			this.t.add(toadd.get(i));		
		}		
	}

	public static void main(String[] args) throws ViellirException {
		Fourmilliere fourm = new Fourmilliere();
		for (int i=1; i<150; i++){
			System.out.println("avant jour " + i + "\n" + fourm.toString()+"\n\n\n\n");
			fourm.evoluer();
		}
	}
}
